﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MSDNReceiver
{
    public class SequenceState
    {
        public SequenceState()
        {
            nextSequenceId = 1;
            outOfSequenceMessages = new Dictionary<int, long>();
        }

        private Dictionary<int, long> outOfSequenceMessages;
        private int nextSequenceId;

        public int GetNextSequenceId()
        { return nextSequenceId; }

        public void SetNextSequenceId(int nextMessage)
        {
            nextSequenceId = nextMessage;
            List<int> cleanupList = new List<int>();

            foreach (KeyValuePair<int, long> msgIdx in outOfSequenceMessages)
            {
                if (msgIdx.Key < nextMessage)
                {
                    cleanupList.Add(msgIdx.Key);
                }
            }
            foreach (int msgIdx in cleanupList)
            {
                outOfSequenceMessages.Remove(msgIdx);
            }

        }

        public long GetNextOutOfSequenceMessage()
        {
            long nextMessage = -1;
            if (outOfSequenceMessages.ContainsKey(nextSequenceId))
            {
                nextMessage = outOfSequenceMessages[nextSequenceId];
            }
            return nextMessage;
        }

        public void AddOutOfSequenceMessage(int sequenceId, long internalMessageSequence)
        {
            outOfSequenceMessages.Add(sequenceId, internalMessageSequence);
        }
    }
}
